unit uHouseholdXXXX;

interface
uses SysUtils;
   type
       arrType = array[1..7] of integer;
       THousehold = class (TObject)
         private
            fAccount  :string;
            fMembers  :integer;
            fWaterUse :arrType;
         public
          constructor create(aAccount : string; aMembers :integer;arrWaterUse : arrType );
          function calculateTotal:integer;
          function calculateAve:double;
          function determineHighDay:integer;
          function determineHighRisk(dayLimit:real):boolean;
          function toString:string;
         
        end;

implementation

 // Q 2.1.1					(3)

constructor THousehold.create(aAccount : string; aMembers:integer; arrWaterUse:arrType);
begin
  fAccount  := aAccount;
  fMembers  := aMembers;
  fWaterUse := arrWaterUse;
end;
//======================================================================
// Q 2.1.2		(4)

function THousehold.calculateTotal:integer;
var
  total, k :integer;
begin
  total := 0;
  for k := 1 to length(fWaterUse) do // or ...to 7
     total := total + fWaterUse[k];  //or inc(total, fWaterUse[k]);

  result := total;
end;
//========================================================================   
 // Q 2.1.3		(2)

function THousehold.calculateAve:double;
begin
        result := calculateTotal / 7;
end;
//==========================================================================
  // Q 2.1.4        		(2)

function THousehold.determineHighDay:integer;
var
  iHighDay,  iHighAmount, k  :integer;
begin
  iHighDay := 1;
  iHighAmount := fWaterUse[1];
  for k := 2 to 7 do
  begin
    if (fWaterUse[k] > iHighAmount) then
     begin
       iHighDay := k;
       iHighAmount := fWaterUse[k];
     end;
     result := iHighDay;
 end;
 end;
//==========================================================================
// Q 2.1.5	(9)

function  THousehold.determineHighRisk(dayLimit:real):boolean;
var
  rAve      :real;
  iCount, k :integer;
begin
    rAve := calculateAve;
		iCount := 0;
		for k := 1 to length(fWaterUse) do
		begin
		  if(fWaterUse[k] > dayLimit) then
		  	inc(iCount);
    end;

		if ((rAve > dayLimit)  OR (iCount > 2)) then
    	 result := true
		else
		   result := false;

end;
//=========================================================================
 // Q 2.1.6	(5) 


function THousehold.toString:string;
var
   sObjStr:string;
   k      :integer;
begin
   sObjStr := 'Account number: ' + fAccount + #13 + 'Number of members: ' + IntToStr(fMembers) + #13;
   sObjStr := sObjStr + 'Daily water usage' + #13 + 'Days:         ' + #9;
	 for k := 1 to 7 do
 	 		 sObjStr := sObjStr + intToStr(k) + #9;

	 sObjStr := sObjStr + #13 + 'Water used:' + #9;
 	 for k := 1 to length(fWaterUse) do
      sObjStr := sObjStr + IntToStr(fWaterUse[k]) + #9;

    result :=  sObjStr;
end;



end.

